;Cement stirring macro
;Author: Qu
;Version: 1.00

#NoEnv
SendMode Input
SetWorkingDir %A_ScriptDir%
SetDefaultMouseSpeed, 0
SetTitleMatchMode, 3        ;Exact window title match
SetMouseDelay, -1
ATITDWindow:="eGenesis Client ahk_class eGenesis Client"

;Find game window(s)
While (WindowHandle == "" || WindowHandle == 0)
{
  WinWait, %ATITDWindow%
  WinGet, WindowHandle, List, %ATITDWindow%
  If (A_Index > 50)
  {
    MsgBox, Error detecting ATITD Window.
    return
  }
}
If (%WindowHandle% > 1)
{
  MsgBox, Multiple game windows found. Multiple clients not supported. Using the first one found.
}
WinGetPos, WinPosX, WinPosY, WindowWidth, WindowHeight, ahk_id %WindowHandle1%

#IfWinActive eGenesis Client ahk_class eGenesis Client

^!+F10::
ImageSearch, VatX, VatY, 0, 0, WindowWidth, WindowHeight, *60 this_is_a_clinker_vat.png
If (ErrorLevel != 0)
{
  MsgBox, not found
  return
}
Loop
{
  While (StatReady("end") == 0 || StatReady("str") == 0)
  {
    Sleep, 1000
  }
  ImageSearch, CementX, CementY, VatX, VatY, VatX + 200, VatY + 500, *60 stir_the_cement.png
  If (ErrorLevel == 0)
  {
    MouseGetPos, MouseX, MouseY
    MouseClick, Left, CementX, CementY
    MouseMove, MouseX, MouseY
  }
  If (ErrorLevel == 1)
  {
    MouseGetPos, MouseX, MouseY
    MouseClick, Left, VatX, VatY
    MouseMove, MouseX, MouseY
  }
  Sleep, 2000
}
return


;Functions

;Returns 1 if stat is ready
StatReady(Stat)
{
  global WindowHeight
  
  Stats:=7
  
  Stat1Short:="str"
  Stat2Short:="dex"
  Stat3Short:="end"
  Stat4Short:="spd"
  Stat5Short:="con"
  Stat6Short:="foc"
  Stat7Short:="per"
  
  Stat1Long:="strength"
  Stat2Long:="dexterity"
  Stat3Long:="endurance"
  Stat4Long:="speed"
  Stat5Long:="constitution"
  Stat6Long:="focus"
  Stat7Long:="perception"

  If (Stat == "")
  {
    Loop, %Stats%
    {
      If (StatReady(Stat%A_Index%Short) == 0)
      {
        return 0
      }
      If (A_Index == Stats)
      {
        return 1
      }
    }
  }
  
  Loop, %Stats%
  {
    If ((Stat = Stat%A_Index%Short) || (Stat = Stat%A_Index%Long))
    {
      StatName:=Stat%A_Index%Long
      break
    }
    If (A_Index == Stats)
    {
      return 0
    }
  }
  
  If (FindImage(Image(StatName . "_black_tiny.png"), 0, 0, 90, WindowHeight, 0) == 0)
  {
    return 1
  }
  If (FindImage(Image(StatName . "_dark_red_tiny.png"), 0, 0, 90, WindowHeight, 0) == 0)
  {
    return 1
  }
  return 0
}

;Returns 0 if image is found before timeout, otherwise 1
FindImage(Filename, X1="", Y1="", X2="", Y2="", Timeout=500, Variation=60)
{
  global WindowWidth
  global WindowHeight
  StartTime:=A_TickCount
  
  X1:=(X1 == "" ? 0 : X1)
  Y1:=(Y1 == "" ? 0 : Y1)
  X2:=(X2 == "" ? WindowWidth - 1 : X2)
  Y2:=(Y2 == "" ? WindowHeight - 1 : Y2)
  
  X1:=(X1 > 0 && X1 < 1 ? Floor(X1*WindowWidth) : X1)
  Y1:=(Y1 > 0 && Y1 < 1 ? Floor(Y1*WindowHeight) : Y1)
  X2:=(X2 > 0 && X2 < 1 ? Floor(X2*WindowWidth) : X2)
  Y2:=(Y2 > 0 && Y2 < 1 ? Floor(Y2*WindowHeight) : Y2)
  
  Loop
  {
    WinWaitActive()
    ImageSearch, , , X1, Y1, X2, Y2, *%Variation% %Filename%
    If (ErrorLevel == 0 || ErrorLevel == 2)
    {
      return ErrorLevel
    }
    If (A_TickCount > StartTime + Timeout)
    {
      return 1
    }
  }
}

;Finds and clicks an image on the screen. Keeps trying until timeout.
FindClick(Filename, Timeout=0, X1="", Y1="", X2="", Y2="", Variation=60, Button=2)
{
  global WindowWidth
  global WindowHeight
  StartTime:=A_TickCount
  
  ;If these parameters are empty we default to searching the whole game window
  X1:=(X1 == "" ? 0 : X1)
  Y1:=(Y1 == "" ? 0 : Y1)
  X2:=(X2 == "" ? WindowWidth - 1 : X2)
  Y2:=(Y2 == "" ? WindowHeight - 1 : Y2)

  ;If parameters are fractional, we search a fraction of the game area
  ;Be careful not to pass it a fractional value by mistake.. use floor()
  X1:=(X1 > 0 && X1 < 1 ? Floor(X1*WindowWidth) : X1)
  Y1:=(Y1 > 0 && Y1 < 1 ? Floor(Y1*WindowHeight) : Y1)
  X2:=(X2 > 0 && X2 < 1 ? Floor(X2*WindowWidth) : X2)
  Y2:=(Y2 > 0 && Y2 < 1 ? Floor(Y2*WindowHeight) : Y2)

  ;We do at least one loop regardless of timeout
  Loop
  {
    WinWaitActive()
    ImageSearch, FoundX, FoundY, X1, Y1, X2, Y2, *%Variation% %Filename%
    If (ErrorLevel == 2)
    {
      return 2
    }
    If (ErrorLevel == 0)
    {
      MouseClick, Left, FoundX, FoundY
      return 0
    }
    If (A_TickCount > StartTime + Timeout)
    {
      return 1
    }
  }
}

Image(Filename)
{
  return Filename
}

WinWaitActive(Handle="")
{
  global WindowHandle1
  
  Handle:=(Handle == "" ? WindowHandle1 : Handle)
  While (WinActive("A") != Handle)
  {
    Sleep, 10
  }
  return 1
}

;Macro hotkeys
#IfWinActive
^!+r::Reload
^!+e::Edit